let specials1 = [7;3;6;10;5;7;8;3;4;4;9;7;3;8;3;7]
let digits    = [7;4;6;7;8;7;7;7;7;7]
let specials2 = [3;3;5;8;5;5;9]
let uppercase = [10;7;8;8;8;7;8;8;7;8;6;8;8;7;8;8;8;8;8;9;8;10;14;7;9;7]
let specials3 = [5;7;5;4;8;3]
let lowercase = [7;7;6;7;6;5;7;7;3;5;6;3;11;7;7;7;7;6;5;5;7;7;10;6;7;5]
let specials4 = [5;3;5;5]

(* since reading is buffered it is essential to evaluate [f x] *)
let rec eager_map f = function
 | []    -> []
 | x::xs -> let r = f x in r::eager_map f xs

let split_line s ls =
  let rec split_line cs = function
    | []    -> []
    | l::ls -> Lst.take l cs :: split_line (Lst.drop l cs) ls
  in
  split_line (Strng.of_string s) ls

let chin = open_in "ascii-art-symbols.txt"

let read_line ls = eager_map (fun() -> split_line (input_line chin) ls)
(Lst.replicate 8 ());;

let symbols = eager_map read_line
  [specials1;digits;specials2;uppercase;specials3;lowercase;specials4];;
let ascii_letters = Lst.foldr (List.map2 (@)) (Lst.replicate 8 []) symbols;;

close_in chin;;

let char c =
  let i = int_of_char c - int_of_char ' ' in
  Picture.stack (eager_map Picture.row (eager_map (fun l -> List.nth l i) ascii_letters))
;;
