(* range : int -> int -> int list *)
let rec range m n = if m >= n then []
                              else m::range (m+1) n
(* sum : int list -> int *)
let sum xs = Lst.foldr ( + ) 0 xs
(* prod : int list -> int *)
let prod xs = Lst.foldr ( * ) 1 xs
(* mean_arith *)
(* mean_geom *)
(* gsum *)
(* euler *)
(* leibniz *)

(* W08 *)
(* average : int list -> int *)
let average xs = sum xs / Lst.length xs
(* sumlen : int list -> int * int *)
let rec sumlen = function
 | []    -> (0,0)
 | x::xs -> let (sum,len) = sumlen xs in (sum+x,len+1)
(* average1 : int list -> int *)
let average1 xs = let (sum,len) = sumlen xs in sum/len
(* sumlen_tl : int list -> int * int *)
let sumlen_tl xs =
 let rec sumlen sum len = function
  | []    -> (sum,len)
  | x::xs -> sumlen (sum+x) (len+1) xs
 in
 sumlen 0 0 xs
(* sumlen_fold : int list -> int * int *)
let sumlen_fold xs = 
 Lst.foldl (fun (sum,len) x -> (sum+x,len+1)) (0,0) xs

(* E13 *)
(* auxiliary functions *)
(* range_tl : int -> int -> int list *)
let range_tl m n =
 let rec range acc m n =
  if m >= n then acc else range ((n-1)::acc) m (n-1)
 in
 range [] m n
(*  *)
